/*
    Common commands implementation.
    Copyright (C) 2011 2012  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __CMD_COMMON_H
#define __CMD_COMMON_H	1


#include <modbus/modbus.h>

/***************************************************************************/
/* define pubblici */

/***************************************************************************/
/* macro pubbliche */

/***************************************************************************/
/* strutture pubbliche */

/***************************************************************************/
/* costanti pubbliche */

/***************************************************************************/
/* variabili pubbliche */

extern modbus_param_t	Link;			// modbus link desc.

/***************************************************************************/
/* funzioni pubbliche */

int syncCmd(int argc,char **argv);
  /* Sincronizzza lo stato del sequencer con lo stato del controller remoto. */

int moveCmd(int argc,char **argv);
  /* Muove il servo specificato alla posizione inidcata. */

int dmoveCmd(int argc,char **argv);
  /* Muove una coppia di servi alla posizione specificata. */

int speedCmd(int argc,char **argv);
  /* Imposta la velocita' per il servo indicato. */

int pauseCmd(int argc,char **argv);
  /* Esegue una pausa espressa in millisecondi. */

int waitCmd(int argc,char **argv);
  /* Attende che il servo indicato abbia raggiunto la propria destinazione. */

int timingCmd(int argc,char **argv);
  /* Imposta una nuova strategia di timing. */

/***************************************************************************/
#endif

/* $Source$ */

