/*
    Command definition macros.
    Copyright (C) 2011  Alessandro Accattini

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


 *****************************************************************************
 *
 *
 * $Header$
 *
 *
 *
 * REVISION HISTORY:
 * $Log$
 */

#ifndef __CMD_DEF_H
#define __CMD_DEF_H	1


/***************************************************************************/
/* define pubblici */

#define SHELL_CMD_SECTION	0		// enable linker section

/***************************************************************************/
/* strutture pubbliche */

typedef struct
{
  const char	*Cmd;				// nome del comando
  int		(*ActFunc)(int,char **);	// funzione associata
  const char	*ShortHelp;			// help breve del comando
  const char	*LongHelp;			// help completo del comando
}ShellCmd_t;
  
/***************************************************************************/
/* macro pubbliche */

#if SHELL_CMD_SECTION
#define ADD_SHELL_CMD(cmd,help,longhelp) ShellCmd_t __shell_cmd_##cmd __attribute__ ((unused,section (".shell_cmd"))) = {#cmd,cmd##Cmd,help,longhelp}
#else
#define ADD_SHELL_CMD(cmd,help,longhelp) {#cmd,cmd##Cmd,help,longhelp}
#endif

/***************************************************************************/
/* costanti pubbliche */

/***************************************************************************/
/* variabili pubbliche */

#if SHELL_CMD_SECTION
extern ShellCmd_t	__shell_cmd_start;	// inizio tabella comandi
extern ShellCmd_t	__shell_cmd_end;	// fine tabella comandi
#endif

/***************************************************************************/
/* funzioni pubbliche */

/***************************************************************************/
#endif

/* $Source$ */

